

<mat-form-field>
    <mat-label>Filter</mat-label>
    <input matInput (keyup)="applyFilter($event)" [attr.data-test]="dataTestFilter" #input>
</mat-form-field>

<div class="mat-elevation-z8">
    <table mat-table [dataSource]="dataSource" matSort [attr.data-test]="dataTest">
        @for (column of data?.columns; track column) {
        <ng-container [matColumnDef]="column.key">
            <th mat-header-cell *matHeaderCellDef mat-sort-header> {{column.label}} </th>
            <td mat-cell *matCellDef="let row"> {{row[column.key]}} </td>
        </ng-container>
        }

        <tr mat-header-row *matHeaderRowDef="displayedColumns" class="list-header"></tr>
        <tr mat-row *matRowDef="let row; columns: displayedColumns;" (click)="onItemClick(row)" class="list-item clickable"></tr>

        <!-- Row shown when there is no matching data. -->
        <tr class="mat-row" *matNoDataRow>
            <td class="mat-cell" colspan="4">No data matching the filter "{{input.value}}"</td>
        </tr>
    </table>
    <mat-paginator [pageSizeOptions]="[5, 10, 25, 100]" aria-label="Select page"></mat-paginator>
</div>